
#include "cloud.h"

/*
Mutation of JRC version of Kriebel and Saunders, DAYTIME algorithm.
Will also work at nighttime PROVIDED that nighttime dummy reflectance values
R1 and R2 are <= 0.

Returns 0 if clear pixel, non-zero if cloudy pixel.

Thresholds updated for Collection 6, along with an additional very simple
reflectance cloud test specifically for water pixels.

Revised for Collection 6.
*/
int iscloud(float R1, float R2, float T32, int water)
{
	int test1, test2, test3a, test3b, test4;

#ifdef C4C5
	test1 = (R1 + R2) > 0.9F;
	test2 = T32 < 265.0F;
	test3 = (R1 + R2) > 0.7F;
	test4 = T32 < 285.0F;

	return test1 || test2 || (test3 && test4);
#endif

	test1 = (R1 + R2) > 1.2F;
	test2 = T32 < 265.0F;

	test3a = (R1 + R2) > 0.7F;
	test3b = T32 < 285.0F;

	test4 = water && (T32 < 300.0F) && (R2 > 0.25F);

	return test1 || test2 || (test3a && test3b) || test4;
}

